=== examples/CMakeLists.txt ===
add_subdirectory(AllTests)
add_subdirectory(ApplicationLib)
