=== examples/ApplicationLib/CMakeLists.txt ===
add_library(ApplicationLib
    CircularBuffer.cpp
    EventDispatcher.cpp
    hello.c
    Printer.cpp
)
