=== debian/changelog ===
cpputest (4.0-3) unstable; urgency=medium

  * Hardcode installation prefix in cmake scripts (Closes: #1099339,
    LP: #1990274)
  * Update lintian overrides
  * Bump Standards-Version to 4.7.2
  * Add a patch to fix make distclean and thus support building twice in a row
    (Closes: #1044148, #1049757)

 -- Raphaël Hertzog <hertzog@debian.org>  Fri, 21 Mar 2025 10:16:10 +0100

cpputest (4.0-2) unstable; urgency=medium

  * Fix autopkgtest
  * Disable build log scanner as it fails on a false-positive

 -- Raphaël Hertzog <hertzog@debian.org>  Sun, 09 Aug 2020 00:02:52 +0200

cpputest (4.0-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/changelog: Remove trailing whitespaces

  [ Raphaël Hertzog ]
  * Add a git-buildpackage configuration file
  * New upstream version 4.0
  * Drop patches merged upstream
  * Switch to debhelper compat level 13
  * Bump Standards-Version to 4.5.0
  * Update list of docs files to include
  * Update rules to no longer touch removed files
  * Drop upstream's problematic .gitignore
  * Add salsa CI configuration file
  * Install the new cmake files in libcpputest-dev
  * Add some lintian overrides for
    package-contains-documentation-outside-usr-share-doc

 -- Raphaël Hertzog <hertzog@debian.org>  Sat, 08 Aug 2020 23:02:15 +0200
