=== debian/watch ===
version=3
https://github.com/cpputest/cpputest/releases \
 .*/releases/download/.*/[Cc]pp[Uu][Tt]est-v?(\d[\d.]*)\.tar\.gz
